import processing.opengl.*;
import ddf.minim.*;
import oscP5.*;
import netP5.*;

PrintWriter output;

final boolean debug=false;

OscP5 oscP5;
NetAddress myRemoteLocation;

Minim minim;
  boolean removeLine,on;
AudioSample move,tombe,tourne,ligne;
AudioPlayer titre;

int _line,_score,_line2,_score2;
final int gridWidth=10; 
final int gridHeight=25;
final int gridHidden=2;
final int gridStartX=40;
final int gridStartY=20;
int speedDelay=1000;    // ms between steps
int grid[][];
int rectWidth, rectHeight;
float timer;
int rectY;
int tetrPosX, tetrPosY, tetrType, tetrRot, tetrSize;
boolean tetrLocked, tetrDownStep, tetrDrop;

int tetrSaved;
boolean tetrCanSave;

final int maxQueue=3;
int tetrQueue[];
int queueX, queueY;
int fade;
boolean gameOver=true,start=true,display2=true,gameOver2=true;
PFont f;
PImage a,b,d,c;
int tim;

void setup() {
  frame.setTitle("Super Tetris Adventure | Joueur 2"); 
  size (800,600,OPENGL);
noCursor();

  oscP5 = new OscP5(this,12001);
myRemoteLocation = new NetAddress("127.0.0.1",12000);

 minim = new Minim (this);
a = loadImage ("title.png");
b = loadImage ("fond.png");
c = loadImage ("bloc.png");
d = loadImage ("barre.png");
   f= loadFont ("PressStartK-12.vlw");
output = createWriter("score.txt");

move= minim.loadSample("move.wav");
tombe= minim.loadSample("tombe.wav");
tourne= minim.loadSample("tourne.wav");
ligne= minim.loadSample("ligne.wav");
titre= minim.loadFile("tetris.mp3",2048);
  grid = new int[gridWidth][gridHeight];
    textFont (f);
  for (int x=0;x<gridWidth;x++) {
    for (int y=0;y<gridHeight;y++) {
      grid[x][y]=0;
    }
 
  }  
  

  rectWidth = int(200/10);
  rectHeight = int(400/20);
  queueX = 11+gridStartX+rectWidth*gridWidth;
  queueY = 20;

  tetrQueue = new int[maxQueue];
  for(int i=0;i<maxQueue;i++) {
    tetrQueue[i]=round(random(0,6));
  }
  tetrNew();  
  
  tetrSaved=7;
  tetrCanSave=true;
  timer = millis();
}

void draw() {
   
    background(128);
 
    

  
  if (!gameOver){ titre.rewind();  titre.pause();
}  
     if (gameOver){titre.play();
}  
   
   if (removeLine){
     println ("mercdssdse");
     on=true;
     


     }
  

    console.draw();
    OscMessage myMessage2 = new OscMessage("/score");
    OscMessage myMessage3 = new OscMessage("/line");
myMessage2.add(_score);
myMessage3.add(_line);
  oscP5.send(myMessage2, myRemoteLocation);
    oscP5.send(myMessage3, myRemoteLocation);
  renderGrid();
  renderQueue();
//fill(128);
//rect(0,0,400,20);
 noTint();
    image (b,0,0);
        fill(255);
  text ("JOUEUR 1",200,520);
  text ("Line: "+_line2,200,550);
 text ("Score: "+_score2,200,570);
 ///
   text ("JOUEUR 2",600,520);
  text ("Line: "+_line,600,550);
 text ("Score: "+_score,600,570);


  console.startGame();
   
       
  if (!gameOver && (millis()>timer+speedDelay || tetrDownStep || tetrDrop)) {
    if (!tetrDrop) {
      tetrStepDown();
   
    } else {
      while (tetrDrop) { // Should be able to move left/right before full Drop. 
        tetrStepDown();
        tetrDrop = tetrCheckMove(0,1);
      }
    }

    tetrDownStep=false;
    tetrDrop=false;
    timer = millis();
  }  

  if (gameOver) {
    tetrLocked=true;
  //  renderGameOver();
    console.gameOver();
   
  }
}

void renderQueue() {
  
  for(int y=0;y<4;y++) {
    for(int x=0;x<4;x++) {
      switchFillColor(gridTemplate[tetrQueue[0]][0][y][x]);
      image(c,(queueX+x*rectWidth)-210,500+y*rectHeight);
       fill(0,128);
     // rect(3+(queueX+x*rectWidth)-210,3+500+y*rectHeight,rectWidth-6,rectHeight-6); 
   
  }
  }
 
  for(int i=1;i<maxQueue;i++) {
    for(int y=0;y<4;y++) {
      for(int x=0;x<4;x++) {
        int yi = 10+queueY+4*rectHeight+((i-1)*(10+4*(rectHeight/2)));
        switchFillColor(gridTemplate[tetrQueue[i]][0][y][x]);
      //  rect((rectWidth*2)+queueX+x*(rectWidth/2),yi+(y*(rectHeight/2)),rectWidth/2,rectHeight/2);
      }
    }
  }

  int yi = ((gridHeight-gridHidden-4)*rectHeight)-queueY;
  for(int y=0;y<4;y++) {
    for(int x=0;x<4;x++) {
      switchFillColor(gridTemplate[tetrSaved][0][y][x]);
    //  rect(queueX+x*rectWidth,yi+y*rectHeight,rectWidth,rectHeight);
    }
  }
}

void renderShadow() {
  int xx=tetrPosX;
  int yy=tetrPosY;;
  boolean moveOK=false;
  while (tetrCheckMove(0,1,xx,yy,tetrRot)) {
    yy++;
  }
  
  for(int y=0;y<tetrSize;y++) {
    for(int x=0;x<tetrSize;x++) {
      if (gridTemplate[tetrType][tetrRot][y][x]!=0 && y+yy>=gridHidden) {
        if (gridTemplate[tetrType][tetrRot][y][x]!=0) fill(20);
        rect(gridStartX+(x+xx)*rectWidth,gridStartY+((y+yy-gridHidden)*rectHeight),rectWidth,rectHeight);
      }
    }
  }
}

void renderGameOver() {
//  textFont(f, 32);
 // fill(255);
 // int x = int(((gridWidth*rectWidth)/2)-(textWidth("ooops...")/2));
 // text("ooops...", x, 295);
}

// Save tetrimino for later
void tetrSave() {
  int t = tetrSaved;
  tetrSaved = tetrType;
  if (t==7) {
    tetrNew();
  } else {
    tetrNew(t);
    tetrCanSave=false;
  }
}

// Move tetrimino one step down, returns TRUE if has been stopped.
boolean tetrStepDown() {
  boolean moveOK = tetrCheckMove(0,1);
       ///blocage///
       
  
       if (tetrPosY >= 24){tetrPosY =24; tombe.trigger(); tetrFixToGrid();
      gridCheck();
      tetrNew();
      tetrCanSave=true;} 
  
  
      
  if (moveOK) {
    tetrPosY++;
  } else {
       tombe.trigger();
    if (tetrPosY!=0) {
     
      tetrFixToGrid();
      gridCheck();
      tetrNew();
      tetrCanSave=true;
    } else {
      gameOver=true;
       display=true;
    }
  }

  return !moveOK;
 
}

// General routine that performs Check before moving
boolean tetrCheckMove(int xm, int ym) {
  return tetrCheckMove(xm, ym, tetrPosX, tetrPosY, tetrRot);
}

boolean tetrCheckMove(int xm, int ym, int tetrX, int tetrY, int tetrR) {
  boolean moveOK=true;
  int gridC=0;
  if (debug) System.out.println("==");
  for(int y=0;y<tetrSize;y++) {
    for(int x=0;x<tetrSize;x++) {
      if ((tetrY+y+ym<0 || tetrY+y+ym>=gridHeight) || (tetrX+x+xm<0 || tetrX+x+xm>=gridWidth)) {
        gridC=1;
      } else {
/*        if (xm!=0) {
          gridC=grid[tetrX+x+xm][tetrY+y];
        } else if (ym!=0) {
          gridC=grid[tetrX+x][tetrY+y+ym];
        } else if (ym==0 && xm==0) {
          gridC=grid[tetrX+xm][tetrY+y+ym];
        } */
        gridC=grid[tetrX+x+xm][tetrY+y+ym];
      }

      if (debug) System.out.print(gridC + " ");
      if (gridC!=0 && gridTemplate[tetrType][tetrR][y][x]!=0) moveOK=false;
    }
    if (debug) System.out.println();
  }
  
  return moveOK;
  
}

// Check if rotation will move tetrimino outside the grid
boolean tetrCheckRotate(int rm) {
  boolean rotateOK=false;
  int x = tetrPosX;
  int y = tetrPosY;
  int tetrR = tetrRot+rm;
  if (tetrR==4) tetrR=0;
  if (tetrR==-1) tetrR=3;

//  for (int i=0; i<3; i++) {
    rotateOK = tetrCheckMove(0, 0, x, y, tetrR);
    if (!rotateOK) System.out.println(rotateOK);
    if (!rotateOK && tetrCheckMove(-1,0,x,y,tetrR)) {
        x--;
        rotateOK = tetrCheckMove(0, 0, x, y, tetrR);
    }
        
    if (!rotateOK && tetrCheckMove(-2,0,x,y,tetrR)) {
        x=x-2; 
        rotateOK = tetrCheckMove(0, 0, x, y, tetrR);
    }

    if (!rotateOK && tetrCheckMove(+1,0,x,y,tetrR)) {
        x++;
        rotateOK = tetrCheckMove(0, 0, x, y, tetrR);
    }

    if (!rotateOK && tetrCheckMove(+2,0,x,y,tetrR)) {
        x=x+2;
        rotateOK = tetrCheckMove(0, 0, x, y, tetrR);
    }
//  }
  
  if (rotateOK) tetrPosX=x;
  
  return rotateOK;
}

// Check grid for full lines
void gridCheck() {

  for (int y=0;y<gridHeight;y++) {
    removeLine=true;

   
   
    for (int x=0;x<gridWidth;x++) {
      if (grid[x][y]==0) { removeLine=false; fade=0; break;}
    }
    
    // Remove full line //////enlever une ligne////////////////////
    if (removeLine  ) {

      ligne.trigger();
       _line+=1;
       _score+=1000;
       speedDelay-=50;
       //
 OscMessage myMessage = new OscMessage("/score");
myMessage.add(1000);
  oscP5.send(myMessage, myRemoteLocation); 
   OscMessage myMessage2 = new OscMessage("/line");
myMessage2.add(1);
  oscP5.send(myMessage2, myRemoteLocation); 
       OscMessage myMessage3 = new OscMessage("/nrv");
myMessage3.add(int(random(9)));
  oscP5.send(myMessage3, myRemoteLocation); 
      
   

  
   println (tetrPosX+ " "+y +" "+gridWidth +" "+gridHeight);
   //
 
      for (int yi=y;yi>0;yi--) {
        for (int xi=0;xi<gridWidth;xi++) {
          
           grid[xi][yi]=grid[xi][yi-1];
        }
      }
      for (int xi=0;xi<gridWidth;xi++) {
        grid[xi][0]=0;



      }

  
    }

  }
  }
  //////////////////////////////////////////////////////////

// Fix tetrimino to grid
void tetrFixToGrid() {

  for(int y=0;y<tetrSize;y++) {
    for(int x=0;x<tetrSize;x++) {
      if (debug) System.out.print(gridTemplate[tetrType][tetrRot][y][x]+ "!");
      if (gridTemplate[tetrType][tetrRot][y][x]!=0) {
        grid[tetrPosX+x][tetrPosY+y]=gridTemplate[tetrType][tetrRot][y][x];
      }
    }
    if (debug) System.out.println("");
  }
}

// Set new tetrimino
void tetrNew() { 
  int type=tetrQueue[0];
  for(int i=0;i<maxQueue-1;i++) {
    tetrQueue[i]=tetrQueue[i+1];
  }
  tetrQueue[maxQueue-1]=round(random(0,6));

  tetrNew(type);  
}

void tetrNew(int type) {
  tetrType=type;
  if (tetrType==0 || tetrType==3) tetrSize=4; else tetrSize=3;

  tetrRot=0;
  tetrPosY=0;
  tetrPosX=int(gridWidth/2)-(tetrSize-1);
}

// Process input
void keyPressed() {
     char k;

  k = (char)key;

  switch(k){
    
  case 8:

    if(buff.length()>0){
      buff = buff.substring(1);
    }
break;






      
 // case 13:  // Avoid special keys
 // case 10:
 // case 65535:
 // case 127:
 // case 27:
   // break;
  default:
  
  
    if(textWidth(buff+k)+leftmargin < width-rightmargin){
      didntTypeYet = false;

   if (nb_buff==9){   
      buff=k+buff;
   }
   
   if (nb_buff!=9){      
     buff=bullshit[nb_buff];

 }


 
    }
    break;
  }
  
  
 
    // MOVE LEFT
            if (key == ENTER || key == RETURN){
         nb_buff=9;
console.retour_a_la_ligne();
      console.controle();
    }
     if (!tetrLocked) {
    if (_debug){
    
    if (keyCode==LEFT) {
      if (debug) System.out.println("--- " + tetrPosX + " " + tetrPosY);          
      if (tetrCheckMove(-1,0)) tetrPosX--;
    }
    
    // MOVE RIGHT
    if (keyCode==RIGHT && tetrCheckMove(1,0)) tetrPosX++;
  
    // DOWN
    if (keyCode==DOWN) tetrDownStep=true;
    
    // UP
    if (keyCode==UP) tetrDrop=true;

    // SAVE TETRIMINO
   // if ((key=='w' || key=='W') && tetrCanSave) tetrSave();
    
    // ROTATE LEFT
   // if ((key=='q' || key=='Q') && tetrCheckRotate(-1)) { tetrRot--; timer = millis(); }
    
    // ROTATE RIGHT
 //   if ((key=='e' || key=='E') && tetrCheckRotate(+1)) { tetrRot++; timer = millis(); }
 
    
    if (tetrRot==4) tetrRot=0;
    if (tetrRot==-1) tetrRot=3;
  }
     }
}

// Render grid and tetrimino to screen
void renderGrid() {
 // stroke(55);
  
  for(int x=0;x<gridWidth;x++) {
    for(int y=0;y<gridHeight;y++) {
        switchFillColor(grid[x][y]);
      //  rect(gridStartX+x*rectWidth,gridStartY+(y-gridHidden)*rectHeight,rectWidth,rectHeight);
     image(c, gridStartX+x*rectWidth,gridStartY+(y-gridHidden)*rectHeight);
       // fill(0,128);
         //       rect(3+gridStartX+x*rectWidth,3+gridStartY+(y-gridHidden)*rectHeight,rectWidth-6,rectHeight-6);
    }
  }  
  
  // render shadow
//  renderShadow();
  
  // render tetrimino
  for(int y=0;y<tetrSize;y++) {
    for(int x=0;x<tetrSize;x++) {
      if (gridTemplate[tetrType][tetrRot][y][x]!=0 && y+tetrPosY>=gridHidden) {
       noTint();
        switchFillColor(gridTemplate[tetrType][tetrRot][y][x]);
        //rect(gridStartX+(x+tetrPosX)*rectWidth,gridStartY+((y+tetrPosY-gridHidden)*rectHeight),rectWidth,rectHeight);
         image (c,gridStartX+(x+tetrPosX)*rectWidth,gridStartY+((y+tetrPosY-gridHidden)*rectHeight));
         // fill(0,128);
           //   rect(3+gridStartX+(x+tetrPosX)*rectWidth,3+gridStartY+((y+tetrPosY-gridHidden)*rectHeight),rectWidth-6,rectHeight-6);
    }
    }
  }
  
}

void switchFillColor(int c) {
  switch (c) {
    case 0: tint(0,0,0); break;
    case 1: tint(0,255,255); break;
    case 2: tint(0,0,255); break;
    case 3: tint(255,165,0); break;
    case 4: tint(255,255,0); break;
    case 5: tint(0,255,0); break;
    case 6: tint(148,0,211); break;
    case 7: tint(255,0,0); break;
    default: tint(255); break;
  }
}

